format	PE GUI 4.0
entry	MyEntry

include '\Program Files\fasm\include\macro\masm.inc'
include '\Program Files\fasm\include\Win32axp.inc'
;include '\Program Files\fasm\include\GlobalMem.inc'

;include	'PdhBrowseCounter.inc'

PDH_BROWSE_DLG_CONFIG	struct		;typedef struct _BrowseDlgConfig 
	ConFlags				dd	?	;{  \\Configuration flags;  
									;DWORD 
									;	bIncludeInstanceIndex  :1;		f
									;	bSingleCounterPerAdd  :1;		t
									;	bSingleCounterPerDialog  :1;	t
									;	bLocalCountersOnly  :1;			f
									;	bWildCardInstances  :1;			t
									;	bHideDetailBox  :1;				t
									;	bInitializePath  :1;			f
									;	bDisableMachineSelection  :1;	f
									;	bIncludeCostlyObjects  :1;		f
									;	bShowObjectBrowser  :1;			f
									;	bReserved  :23;					f
	hWndOwner				dd	?	;HWND hWndOwner;					NULL
	szDataSource			dd	?	;LPTSTR szDataSource;
	szReturnPathBuffer		dd	?	;LPTSTR szReturnPathBuffer;			szPathBuffer
	cchReturnPathLength		dd	?	;DWORD cchReturnPathLength;			MAXPATH
	pCallBack				dd	?	;CounterPathCallBack pCallBack;		NULL
	dwCallBackArg			dd	?	;DWORD_PTR dwCallBackArg;			NULL
	CallBackStatus			dd	?	;PDH_STATUS CallBackStatus;			ERROR_SUCCESS
	dwDefaultDetailLevel	dd	?	;DWORD dwDefaultDetailLevel;		PERF_DETAIL_WIZARD
	szDialogBoxCaption		dd	?	;LPTSTR szDialogBoxCaption;			"Select a counter to monitor."
PDH_BROWSE_DLG_CONFIG	ends		;} PDH_BROWSE_DLG_CONFIG, *PPDH_BROWSE_DLG_CONFIG;

    ERROR_SUCCESS			equ	0
	PERF_DETAIL_WIZARD		equ	400
	MAX_PATH				equ 260

section '.data'	data readable writeable
	_DBCaption	db	"Select a counter to monitor.", 0
	gIst		dd	?
	PathBuf		rb	MAX_PATH

	pbdc		PDH_BROWSE_DLG_CONFIG

section '.code'	code readable executable

MyEntry:
	invoke	GetModuleHandle, 0
	mov		[gIst], eax
	mov		[pbdc.ConFlags], 0110110b
	mov		[pbdc.hWndOwner], NULL
	mov		[pbdc.szDataSource], NULL
	mov		[pbdc.szReturnPathBuffer], PathBuf
	mov		[pbdc.cchReturnPathLength], MAX_PATH
	mov		[pbdc.pCallBack], NULL
	mov		[pbdc.dwCallBackArg], NULL
	mov		[pbdc.CallBackStatus], ERROR_SUCCESS
	mov		[pbdc.dwDefaultDetailLevel], PERF_DETAIL_WIZARD
	mov		[pbdc.szDialogBoxCaption], _DBCaption

	invoke	PdhBrowseCounters,	pbdc

	invoke	MessageBox, 0, [pbdc.szReturnPathBuffer], NULL, MB_OK
	invoke	ExitProcess, 0

section '.idata'	import data readable writeable

	library	kernel32, 	'kernel32', \
			user32, 	'user32', \
			comctl32, 	'comctl32', \
			gdi32, 		'gdi32', \
			pdh,		'pdh.dll'

	include	'\progra~1\fasm\include\apia\kernel32.inc'
	include	'\progra~1\fasm\include\apia\user32.inc'
	include	'\progra~1\fasm\include\apia\comctl32.inc'
	include	'\progra~1\fasm\include\apia\gdi32.inc'
	
	import	pdh, \
			PdhBrowseCounters, 'PdhBrowseCountersA'

;section '.rsrc'	resource from 'BARE.res' data readable
